# SKA SciOps Array Configuration and templates

A Python package to manipulate SKA LOW and MID array layouts. 
It accompanies the [SKAO staged delivery, array assemblies and subarrays](https://www.skao.int/en/science-users/ska-tools/494/ska-staged-delivery-array-assemblies-and-subarrays) 
and the [SKA Low and Mid subarray templates](https://www.skao.int/en/science-users/ska-tools/543/ska-subarray-templates-library) memos.
The generated layouts are compatible with
 CASA [simutil module](https://casadocs.readthedocs.io/en/v6.5.5/examples/community/simulation_script_demo.html) 
and 
[Radio Astronomy Simulation, Calibration, and Imaging Library (RASCIL)](https://developer.skao.int/projects/rascil/en/latest/index.html)
 if you wish to run your own simulations. You can find a few examples in `docs/examples.ipynb`.

Please contact SKAO Science Operations (sciops@skao.int) if you have comments/questions.

## Installation

We use [poetry](https://python-poetry.org/docs/basic-usage/) to manage dependencies in this project. 
You can install `ska_ost_array_config` with

```bash
git clone https://gitlab.com/ska-telescope/ost/ska-ost-array-config.git
cd ska-ost-array-config
poetry install
```

Alternately, you can also install using traditional methods with
```bash
pip install ska-ost-array-config --extra-index-url https://artefact.skao.int/repository/pypi-internal/simple
```

This package has been tested against `python-3.10` and `python-3.11`.

### Installation on Mac with Apple Silicon

On Mac with Apple Silicon, we've noticed that the above commands fail while building `pyFFTW`. If you encounter such an issue, you can install `ska-ost-array-config` as described below:

First, install `FFTW` using `homebrew`.
```bash
brew install fftw
```

Set the temporary environmental variables so that `pyFFTW` can find `FFTW`:
```bash
export DYLD_LIBRARY_PATH=/opt/homebrew/lib/
export LDFLAGS="-L/opt/homebrew/lib/"
export CFLAGS="-I/opt/homebrew/include/"
```

Finally, install `pyFFTW` and `ska-ost-array-config` inside a virtual environment.
```bash
virtualenv -p python3.10 venv
source venv/bin/activate
pip install pyfftw
pip install ska-ost-array-config --extra-index-url https://artefact.skao.int/repository/pypi-internal/simple
```

## Developer notes

If you wish to add more features to this package, feel free to issue a merge request.
We use `black` and `isort` to format our code. Make sure to check the formatting with 

```bash
make python-lint
```


